name: Debugging & exceptions
description: Use a debugger to find bugs in your code faster.
goals:
    debugging: 1
    exceptions: 1
resources:
-   How to learn?:
    -
        link: https://saveall.ai/blog/learning-is-remembering
        title: Save All - Learning is Remembering
        info: An article making the point that in order to grasp complex concepts, you'll first need to *remember* the more basic concepts. This is here to convince you that it may be a good idea to actually *study* the cheat sheet mentioned below.
    -
        link: https://sd42.nl/python-cheat-sheet
        title: LMS42 - Python cheat sheet
        info: We've created a Python cheat sheet, that briefly demonstrates all Python concepts you have learned so far and will learn during the rest of this module. There should also be prints of this floating around our offices. We recommend that you keep one next to your laptop while programming, and that you scan through it (ignoring the parts that you didn't learn yet) every day. The goal is to internalize the syntax to the extend that you can type it automatically, so that you can worry about the problem you're solving instead.
-   Exceptions:
    -
        link: https://realpython.com/python-exceptions/
        title: "Python Exceptions: An Introduction"
        info: Article introducing Python exceptions. 
    -
        link: https://www.youtube.com/watch?v=nlCKrKGHSSk
        title: Socratica - Exceptions in Python
        info: This video explains how the four clauses in Python exception handling (try, except, else, and finally) work.
-   Debugging:
    -
        link: https://www.youtube.com/watch?v=rQ9Ds8Ftfnc
        title: What is Debugging? Why Debugging is Important
        info: The term "debugging" originates from when an actual moth got stuck in a computer. Nowadays, debugging refers to a multi-step process that involves identifying a problem, locating the source of the problem, and correcting or working around it. Debugging is an essential part of the software development process.
    - 
        link: https://www.youtube.com/watch?v=7qZBwhSlfOo
        title: How to Use a Debugger - Debugger Tutorial
        info: Using the Visual Studio Code *debugger* to help you debug Python code.